#! /usr/bin/env ruby
# coding: utf-8

require "helper"
#require "test/unit"
#require "pkg/klass.rb"

class TC_Atom < Test::Unit::TestCase
  def setup
    #s001 = Crysna::Site.new("A", )
    @alo000 = Crysna::Atom.new("Li", "A", [0, 0, 0])
    @alo001 = Crysna::Atom.new("Li", "A", [0, 0, 1])
    @alo010 = Crysna::Atom.new("Li", "A", [0, 1, 0])
    @alo100 = Crysna::Atom.new("Li", "A", [1, 0, 0])
    @alt000 = Crysna::Atom.new("Li", "B", [0, 0, 0])
    @alt001 = Crysna::Atom.new("Li", "B", [0, 0, 1])
    @alt010 = Crysna::Atom.new("Li", "B", [0, 1, 0])
    @alt100 = Crysna::Atom.new("Li", "B", [1, 0, 0])
    @abo000 = Crysna::Atom.new("Be", "A", [0, 0, 0])
    @abo001 = Crysna::Atom.new("Be", "A", [0, 0, 1])
    @abo010 = Crysna::Atom.new("Be", "A", [0, 1, 0])
    @abo100 = Crysna::Atom.new("Be", "A", [1, 0, 0])
    @abt000 = Crysna::Atom.new("Be", "B", [0, 0, 0])
    @abt001 = Crysna::Atom.new("Be", "B", [0, 0, 1])
    @abt010 = Crysna::Atom.new("Be", "B", [0, 1, 0])
    @abt100 = Crysna::Atom.new("Be", "B", [1, 0, 0])
  end

  def test_equal
    assert_equal(true, @alo000 == Crysna::Atom.new("Li", "A", [0, 0, 0]))
    assert_equal(true, @alo001 == Crysna::Atom.new("Li", "A", [0, 0, 1]))
    assert_equal(true, @alo010 == Crysna::Atom.new("Li", "A", [0, 1, 0]))
    assert_equal(true, @alo100 == Crysna::Atom.new("Li", "A", [1, 0, 0]))
    assert_equal(true, @alt000 == Crysna::Atom.new("Li", "B", [0, 0, 0]))
    assert_equal(true, @alt001 == Crysna::Atom.new("Li", "B", [0, 0, 1]))
    assert_equal(true, @alt010 == Crysna::Atom.new("Li", "B", [0, 1, 0]))
    assert_equal(true, @alt100 == Crysna::Atom.new("Li", "B", [1, 0, 0]))
    assert_equal(true, @abo000 == Crysna::Atom.new("Be", "A", [0, 0, 0]))
    assert_equal(true, @abo001 == Crysna::Atom.new("Be", "A", [0, 0, 1]))
    assert_equal(true, @abo010 == Crysna::Atom.new("Be", "A", [0, 1, 0]))
    assert_equal(true, @abo100 == Crysna::Atom.new("Be", "A", [1, 0, 0]))
    assert_equal(true, @abt000 == Crysna::Atom.new("Be", "B", [0, 0, 0]))
    assert_equal(true, @abt001 == Crysna::Atom.new("Be", "B", [0, 0, 1]))
    assert_equal(true, @abt010 == Crysna::Atom.new("Be", "B", [0, 1, 0]))
    assert_equal(true, @abt100 == Crysna::Atom.new("Be", "B", [1, 0, 0]))

    assert_equal(false, @alo000 == Crysna::Atom.new("Li", "A", [0, 0, 1]))
    assert_equal(false, @alo000 == Crysna::Atom.new("Li", "A", [0, 1, 0]))
    assert_equal(false, @alo000 == Crysna::Atom.new("Li", "A", [1, 0, 0]))
    assert_equal(false, @alo000 == Crysna::Atom.new("Li", "B", [0, 0, 0]))
    assert_equal(false, @alo000 == Crysna::Atom.new("Be", "A", [0, 0, 0]))
  end

  #def test_site_name
  #    assert_equal("A", @alo000.site_name)
  #    assert_equal("B", @alt000.site_name)
  #    assert_equal("A", @abo000.site_name)
  #    assert_equal("B", @abt000.site_name)
  #end

  def test_migrate!
    @alo001.migrate!("B", [1, 2, -3])
    assert_equal( Crysna::Atom.new("Li", "B", [1, 2, -2]), @alo001)

    @abo001.migrate!("B", [1, 2, -3])
    assert_equal( Crysna::Atom.new("Be", "B", [1, 2, -2]), @abo001)
  end

  def test_migrate 
    result = @alo001.migrate("B", [1, 2, -3])
    assert_equal( Crysna::Atom.new("Li", "A", [0, 0,    1]), @alo001)
    assert_equal( Crysna::Atom.new("Li", "B", [1, 2, -2]), result)
  end

  def test_centering!
    assert_equal(Crysna::Atom.new("Li", "A", [0, 0, 1]), @alo001)
    @alo001.centering!
    assert_equal(Crysna::Atom.new("Li", "A", [0, 0, 0]), @alo001)
  end

  def test_centering
    assert_equal(Crysna::Atom.new("Li", "A", [0, 0, 0]) , @alo000.centering)
    assert_equal(Crysna::Atom.new("Li", "A", [0, 0, 0]) , @alo001.centering)
    assert_equal(Crysna::Atom.new("Li", "A", [0, 0, 0]) , @alo010.centering)
    assert_equal(Crysna::Atom.new("Li", "A", [0, 0, 0]) , @alo100.centering)
    assert_equal(Crysna::Atom.new("Li", "B", [0, 0, 0]) , @alt000.centering)
    assert_equal(Crysna::Atom.new("Li", "B", [0, 0, 0]) , @alt001.centering)
    assert_equal(Crysna::Atom.new("Li", "B", [0, 0, 0]) , @alt010.centering)
    assert_equal(Crysna::Atom.new("Li", "B", [0, 0, 0]) , @alt100.centering)
    assert_equal(Crysna::Atom.new("Be", "A", [0, 0, 0]) , @abo000.centering)
    assert_equal(Crysna::Atom.new("Be", "A", [0, 0, 0]) , @abo001.centering)
    assert_equal(Crysna::Atom.new("Be", "A", [0, 0, 0]) , @abo010.centering)
    assert_equal(Crysna::Atom.new("Be", "A", [0, 0, 0]) , @abo100.centering)
    assert_equal(Crysna::Atom.new("Be", "B", [0, 0, 0]) , @abt000.centering)
    assert_equal(Crysna::Atom.new("Be", "B", [0, 0, 0]) , @abt001.centering)
    assert_equal(Crysna::Atom.new("Be", "B", [0, 0, 0]) , @abt010.centering)
    assert_equal(Crysna::Atom.new("Be", "B", [0, 0, 0]) , @abt100.centering)
  end

  def test_compare
    #equal
    assert_equal( 0,@alo000 <=> @alo000)
    assert_equal( 0,@alo001 <=> @alo001)
    assert_equal( 0,@alo010 <=> @alo010)
    assert_equal( 0,@alo100 <=> @alo100)
    assert_equal( 0,@alt000 <=> @alt000)
    assert_equal( 0,@alt001 <=> @alt001)
    assert_equal( 0,@alt010 <=> @alt010)
    assert_equal( 0,@alt100 <=> @alt100)
    assert_equal( 0,@abo000 <=> @abo000)
    assert_equal( 0,@abo001 <=> @abo001)
    assert_equal( 0,@abo010 <=> @abo010)
    assert_equal( 0,@abo100 <=> @abo100)
    assert_equal( 0,@abt000 <=> @abt000)
    assert_equal( 0,@abt001 <=> @abt001)
    assert_equal( 0,@abt010 <=> @abt010)
    assert_equal( 0,@abt100 <=> @abt100)

    #
    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Be", "A", [ 0, 0, 0]))
    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Mg", "A", [ 0, 0, 0]))

    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Li", " ", [ 0, 0, 0]))
    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Li", "Z", [ 0, 0, 0]))

    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Li", "A", [ 1, 0, 0]))
    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Li", "A", [-1, 0, 0]))

    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Li", "A", [ 0, 1, 0]))
    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Li", "A", [ 0,-1, 0]))

    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Li", "A", [ 0, 0, 1]))
    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Li", "A", [ 0, 0,-1]))

    #Element is stronger than others.
    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Be", "Z", [ 1, 1, 1]))
    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Mg", " ", [-1,-1,-1]))

    #Sitename is stronger than gloval_vector
    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Li", " ", [ 1, 1, 1]))
    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Li", "Z", [-1,-1,-1]))

    #Order in coordinates
    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Li", "A", [ 1,-1,-1]))
    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Li", "A", [-1, 1, 1]))

    assert_equal(-1,@alo000 <=> Crysna::Atom.new("Li", "A", [ 0, 1,-1]))
    assert_equal( 1,@alo000 <=> Crysna::Atom.new("Li", "A", [ 0,-1, 1]))
  end

  def test_sitename
    assert_equal("A", @alo000.sitename)
    assert_equal("A", @alo001.sitename)
    assert_equal("A", @alo010.sitename)
    assert_equal("A", @alo100.sitename)
    assert_equal("B", @alt000.sitename)
    assert_equal("B", @alt001.sitename)
    assert_equal("B", @alt010.sitename)
    assert_equal("B", @alt100.sitename)
    assert_equal("A", @abo000.sitename)
    assert_equal("A", @abo001.sitename)
    assert_equal("A", @abo010.sitename)
    assert_equal("A", @abo100.sitename)
    assert_equal("B", @abt000.sitename)
    assert_equal("B", @abt001.sitename)
    assert_equal("B", @abt010.sitename)
    assert_equal("B", @abt100.sitename)
    assert_equal("B", Crysna::Atom.new("Be", "B", [1, -1, 0]).sitename)
  end

  def test_full_sitename
    assert_equal("A555", @alo000.full_sitename)
    assert_equal("A556", @alo001.full_sitename)
    assert_equal("A565", @alo010.full_sitename)
    assert_equal("A655", @alo100.full_sitename)
    assert_equal("B555", @alt000.full_sitename)
    assert_equal("B556", @alt001.full_sitename)
    assert_equal("B565", @alt010.full_sitename)
    assert_equal("B655", @alt100.full_sitename)
    assert_equal("A555", @abo000.full_sitename)
    assert_equal("A556", @abo001.full_sitename)
    assert_equal("A565", @abo010.full_sitename)
    assert_equal("A655", @abo100.full_sitename)
    assert_equal("B555", @abt000.full_sitename)
    assert_equal("B556", @abt001.full_sitename)
    assert_equal("B565", @abt010.full_sitename)
    assert_equal("B655", @abt100.full_sitename)
    assert_equal("B645", Crysna::Atom.new("Be", "B", [1, -1, 0]).full_sitename)
  end
end
















